/*
############################################################################
#
#	File:     $RCSfile: i2cmsql.c,v $
#       
#       Revision  $Revision: 1.16 $
#
#	Subject:  Functions to test interface Icon to the C api of msql
#
#	Author:   $Author: kit $
#
#	Date:     $Date: 1996/08/24 22:56:43 $
#
############################################################################
#
#  MsqlConnect(h) returns the a. 
#
#  MsqlSelect(s,db) returns ab. 
#  
############################################################################
#
# $Log: i2cmsql.c,v $
# Revision 1.16  1996/08/24 22:56:43  kit
# *** empty log message ***
#
# Revision 1.15  1996/08/23 02:03:39  kit
# DONE
#
# Revision 1.14  1996/08/21 15:05:42  kit
# Finished revamp of the api
#
# Revision 1.13  1996/08/20 20:00:34  kit
# *** empty log message ***
#
# Revision 1.12  1996/08/19 19:50:31  kit
# *** empty log message ***
#
# Revision 1.11  1996/08/18 16:23:07  kit
# *** empty log message ***
#
# Revision 1.10  1996/08/17 23:24:58  kit
# Starting major rewrite
#
# Revision 1.9  1996/08/16 01:17:16  kit
# Initial version complete
# Beginning Documentation phase & testing
#
# Revision 1.8  1996/07/16 11:23:12  kit
# Debugged and semi-optimiozed
#
# Revision 1.7  1996/07/15 05:55:13  kit
# Initally and lightly tested ass except msqllistfeilds which probably needs work any way
#
# Revision 1.6  1996/07/15 04:47:18  kit
# Found and corrected problem in row selection in msqlfetchrow
#
# Revision 1.5  1996/07/15 02:56:43  kit
# Completed initial interface now beginning testing and tuning
#
# Revision 1.4  1996/07/12 06:58:33  kit
# Okay fixed it
#
# Revision 1.3  1996/07/12 06:50:47  kit
# *** empty log message ***
#
# Revision 1.2  1996/07/12 06:43:55  kit
# *** empty log message ***
#
# Revision 1.1  1996/07/11 02:23:56  kit
# Initial revision
#
# Revision 1.1  1996/07/09 02:28:52  kit
# Initial revision
#
# Revision 1.2  1996/07/08 05:50:29  kit
# Got everything right, now going on to test other types
#
# Revision 1.1  1996/07/08 04:57:48  kit
# Initial revision
#
#
############################################################################
*/

#include "icall.h"
#undef __P /* Eliminates cheesey Redefine error between msql.h and cdefs.h */
#include "/usr/local/Minerva/include/msql.h"
#include "i2cmsql.h"

int msql_connect(int argc, descriptor *argv)  /*: Connect to server on host v */
{
  char *v;
  int handle;
  ArgString(1);	              
  v = StringVal(argv[1]);	
  handle = msqlConnect((strcmp("local",v)==0) ? (char *)NULL : v);
  if (handle!=-1){ 
        if(host_table[handle] != NULL) free(host_table[handle]); 
    host_table[handle]=(char *)malloc(strlen(v)+1);
    strcpy(host_table[handle],v);
    RetInteger(handle);	
  }else
    Fail; /* Error Connecting */
}

int msql_seldb(int argc, descriptor *argv)      /*: Select DB db on sock s */
{
  int handle;
int hand;
  char *x;
  m_result *tab_buf;
  m_row row_buf;
  char table_table_temp[4000];
  ArgInteger(1);
  ArgString(2);
  x=(StringVal(argv[2]));
  handle=msqlSelectDB(hand=IntegerVal(argv[1]),x);
  if (handle != -1){
    if(db_table[hand] != NULL) free(db_table[hand]);    
    db_table[hand]=(char *)malloc(strlen(x)+1);
    strcpy(db_table[hand],x);
    tab_buf = msqlListTables(hand); 
    strcpy(table_table_temp,"\0");
    while(row_buf=msqlFetchRow(tab_buf)){
      strcat(table_table_temp,row_buf[0]);
      strcat(table_table_temp,",");
    }
    table_table[hand]=(char *)malloc(strlen(table_table_temp)+10);
    strcpy(table_table[hand],table_table_temp);
    msqlFreeResult(tab_buf);
    RetInteger(hand);
  } else 
    Fail;        /* Error opening DB */
}

int msql_sel(int argc, descriptor *argv) /*: "select" querry q to on sock s*/
{
  descriptor d;
  int s,result;
  char *q; 
  int x;
  m_result *xx;
  ArgInteger(1);
  ArgString(2);
  s=IntegerVal(argv[1]);
  q=StringVal(argv[2]);
  cursor[s]=0;
  if(results[s]!=(m_result *)NULL)
    msqlFreeResult(results[s]);
  if (msqlQuery(s,q) != -1){
    results[s]=msqlStoreResult();
    total[s]=msqlNumRows(results[s]);
    cols[s]=msqlNumFields(results[s]);
    return(0);
  }else{  
    results[s]=NULL; 
    Fail;    /* query Failed or bad sock */
  }
}


int msql_execl(int argc, descriptor *argv) /*: Operation querry q on sock s*/
{
  int s,result;
  char *q;
  ArgInteger(1);
  ArgString(2);
  s=IntegerVal(argv[1]);
  q=StringVal(argv[2]);
  if (msqlQuery(s,q) != -1)
    return(0);
  else 
    Fail;
}

int msql_free_result(int argc, descriptor *argv) /*: release result */ 
{ 
  ArgInteger(1);
  msqlFreeResult(results[IntegerVal(argv[1])]);
  return(0);
} 


int msql_fetch_row_string(int argc, descriptor *argv)  /*: fetch row */
{ 
  int  handle;
  m_row result;
  int x, num_fields,tot;
  m_row row;
  m_field *sz;
  char *buf;
    int i;
  m_field *wack;
  ArgInteger(1);
  handle =IntegerVal(argv[1]);
  num_fields=cols[handle]; 
  if (  (total[handle] == 0) || (!(row = msqlFetchRow(results[handle])))  ){ 
    return -1;
  } else { 
    cursor[handle]++;
    for(tot=0;(sz=msqlFetchField(results[handle]))!=NULL;){ 
      tot+=sz->length;                              
    }
    buf=(char *)malloc(tot+1); 
    strcpy(buf,"");
    msqlFieldSeek(results[handle],0);
    for(x=0; x < num_fields;x++){
      strcat(buf,row[x]);
      sz=msqlFetchField(results[handle]);
      for(i=0;i<((sz->length)-strlen(row[x]));i++)
	strcat(buf," ");
    }
    RetStringNFree(buf);
  }  
}


int msql_data_see(int argc, descriptor *argv) /*: move to a row n */
{
  int tmp2,handle;
  ArgInteger(1);
  ArgInteger(2);

  msqlDataSeek(results[handle=IntegerVal(argv[1])],tmp2=(int)IntegerVal(argv[2]));
  if (tmp2==0)
    cursor[handle]=0;
  else
    cursor[handle]+=tmp2;
  return(0);
}

int msql_field_seek(int argc, descriptor *argv) /*: move to field n */
{
  ArgInteger(1);
  ArgInteger(2);
  msqlFieldSeek(results[IntegerVal(argv[1])],(int)IntegerVal(argv[2]));
  return(0);
}


int msql_num_rows(int argc, descriptor *argv) /*: obtain the number of rows */
{ int z;
  ArgInteger(1);
  z=IntegerVal(argv[1]);
  RetInteger(msqlNumRows(results[z]));
}

int msql_fetch_field_string(int argc, descriptor *argv) /*: fetch info about the feilds */
{
  m_field *x;
  char *buf;
  ArgInteger(1);
  if ((x=msqlFetchField(results[IntegerVal(argv[1])])) != NULL){
  buf=(char *)malloc(sizeof(x->name)+sizeof(x->table)+sizeof(x->type)+sizeof(x->length)+sizeof(x->flags));
  sprintf(buf,"%s,%s, %d, %d, %d",x->name,x->table,x->type,x->length,x->flags);
  RetStringNFree(buf);}
  else {
    Fail;
  }
}

int msql_num_fields(int argc, descriptor *argv) /*: Return number of fields */
{
  int z;
  ArgInteger(1);
  z=IntegerVal(argv[1]);
  RetInteger(msqlNumFields(results[z]));
}

int msql_dbs_string(int argc, descriptor *argv) /*: returns a list of dbs */ 
{
  ArgInteger(1);
  results[0]=msqlListDBs((int)IntegerVal(argv[1]));
  if (! results[0]) Fail;
  RetInteger(0);
}

int msql_fetch_one(int argc, descriptor *argv) /*: fetch one field from row */
{ m_row x;
 char *buff; 
  ArgInteger(1);
  if (!(x=msqlFetchRow(results[IntegerVal(argv[1])]))) Fail;
   buff=(char *)malloc(sizeof(x[0])+1);
  strcpy(buff,"");  
  strcat(buff,(char *)x[0]);
  strcat(buff,"");
  RetString(buff);
}

int msql_ables (int argc, descriptor *argv) /*: returns a list of tables */
{
  int x;
  ArgInteger(1);
  x=IntegerVal(argv[1]);
  RetString(table_table[IntegerVal(argv[1])]);
}

int msql_list_fields(int argc, descriptor *argv) /*: returns a list of fields */
{
  ArgInteger(1);
  ArgString(2);
  results[2]=msqlListFields(IntegerVal(argv[1]),StringVal(argv[2]));
  RetInteger(2);
}

int msql_close(int argc,descriptor *argv) /*: closes the database */
{ int handle;
  ArgInteger(1);
  msqlClose(handle=IntegerVal(argv[1]));
  free(db_table[handle]);
  free(host_table[handle]); 
  return(0);
}

int msql_which_host(int argc, descriptor *argv) /*: look up in host_table */
{
  char *x;
  int y;
  ArgInteger(1);
  y=IntegerVal(argv[1]);
  x=host_table[y];   
  RetString(x);
}

int msql_which_db(int argc, descriptor *argv) /*: look p in host_table */
{
  char *x;
  int y;
  ArgInteger(1);
  y=IntegerVal(argv[1]);
  x=db_table[y];   
  RetString(x);

}

int msql_get_cursor(int argc, descriptor *argv) /*: lo up in host_table */
{
  ArgInteger(1);
  RetInteger(cursor[IntegerVal(argv[1])]);
}

int msql_get_total(int argc, descriptor *argv) /*: look up in host_table */
{
  ArgInteger(1);
  RetInteger(total[IntegerVal(argv[1])]);
}

int msql_what_error(int argc, descriptor *argv) /*: look up Error mesage */
{
  if(msqlErrMsg != NULL)  RetString(msqlErrMsg);
  else Fail;
}










